



#include<vector.h>
#include<fstream.h>
#include<iostream.h>
#include<bitset.h>
#include<assert.h>
#include <algorithm>
#include<algorith>
#include<string.h>


using namespace std;
struct Bit
{
 unsigned long int  Field:1;
};





class BitString
{
  private:
    vector<Bit>::iterator p;
    vector<Bit>::iterator e;
    vector<Bit>::iterator dl;
    void Convert_Int_To_Bit(unsigned long int);
    
    vector<Bit> BString;


  public:
    BitString();
    ~BitString();
    Bit bt1;
    Bit bt0;

    void Mod2(BitString);
    unsigned long int operator[](unsigned long int);
    void operator=(BitString);


    unsigned long int SizeStr(void); // -
              
    void ClearStr(void);         //   -
    void InsertBit(unsigned long int ,unsigned long int,Bit);//    index
    unsigned long int MaxSize(void);           //  ,    
                                               // 
    void PuchBack(Bit);          // .(  )
    void PopBack(void);              //  
    void ReSizeStr(unsigned long int,Bit); //  
    void RandomStr(int);                //  
                                        // index(<=5)
    void ReverseStr(void);//     
    void LeftStr(int e);//    
                        //
    void RightStr(int e);// /    
                        //
    void JoinStr(BitString x);// 
                                           //   X
    void StrToBit(char *);  //    
    char* BitToChar(void);//    
    void WriteStr(char*);//    
    void EraseBit(unsigned long int); // 
    void EraseStr(unsigned long int,unsigned long int);// 
    void SwapBit( unsigned long int,unsigned long int );//    
    int Count_1(void);// - "1" 
    int Count_0(void);// - "0" 
    void WriteStrRev(char*); //    ,     WriteStr() -
                             //      
    void ReadStrRev(char*);//  ()
    void ReadStr(char*)  ;//  
    int FindStr(BitString);//   , 
                           //     
    void InvBit(unsigned long int );// 
    void InvStr(void);//  
    void Init_1(unsigned long int);//  "1"
    void Init_0(unsigned long int);//  "0"
    void IntToBit(unsigned int);//  ( )  
    Bit SumReg(BitString);//    
    void GenPSP(BitString,int);//    
    void ConvertToRev(void);//     

};
//---------------------------------
void BitString::ConvertToRev(void)
{
  unsigned char h=1;
  Bit y;
  unsigned char g=0;
 int f=0;
 BitString tt;tt.ClearStr();
 for(unsigned long int count=0;count<=this->BString.size();count++)
 {
   if(f==8)
    {
     f=0;
     do
 {
  
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   tt.BString.push_back(y);
   g>>=1;
  }
 }while (count<=0);


     g=0;
    }
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g=g+128;break;
              case 1:g=g+64; break;
              case 2:g=g+32; break;
              case 3:g=g+16; break;
              case 4:g=g+8;  break;
              case 5:g=g+4;  break;
              case 6:g=g+2;  break;
              case 7:g++;    break;
             }
    }


  f++;
 }
 this->BString=tt.BString;
 }
//---------------------------------
/*void BitString::GenPSP(BitString z,int y)
{
 BitString lll;
 this->ClearStr();
 Bit g;
 int t=z.SizeStr();
 lll.StrToBit("10000");
 for(int i=0;i<=y;i++)
 {
  g=this->SumReg(z);
  this->BString[i].Field=z.BString[t].Field;
  this->RightStr(1);
  z.BString[0]=g;
 }
}  */
//---------------------------------
Bit BitString::SumReg(BitString x)
{
 Bit ui;
 unsigned int z=0;
 for(unsigned long int i=0;i<=x.SizeStr();i++)
 {
  if(this->BString[i].Field==1 &&   x.BString[i].Field==1)
  {
  if(z==0)z++;
  else z--;
  }
 }
 if(z==true)ui.Field=1;   
 else ui.Field=0;
 return ui;
}
//---------------------------------
void BitString::IntToBit(unsigned int x)
{
 this->ClearStr();
 unsigned int g;
 unsigned int h=1;

 Bit y;


  g=x;
  for(int i=0;i<=32;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g>>=1;
  }

}
//---------------------------------
void BitString::ReadStrRev(char*Path)
{
 this->ClearStr();
 unsigned char g=0;
 unsigned char h=1<<7;

 Bit y;
 ifstream infile(Path,ios::in);
 do
 {
  infile>>g;
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g<<=1;
  }
 }
 while(infile.eof()==false);
 infile.close();
}
//---------------------------------
void BitString::Init_0(unsigned long int x)
{
 this->ClearStr();
 for(unsigned long int i=0;i<=x;i++)BString.push_back(bt0);
}
//---------------------------------
void BitString::Init_1(unsigned long int x)
{
 this->ClearStr();
 for(unsigned long int i=0;i<=x;i++)BString.push_back(bt1);
}

//---------------------------------
void BitString::InvStr(void)
{
 for(unsigned long int i=0;i<=BString.size();i++)
 {
   if(this->BString[i].Field==1)this->BString[i].Field=0;
   else this->BString[i].Field=1;
 }
}
//---------------------------------
void BitString::InvBit(unsigned long int x)
{
 if(this->BString[x].Field==1)this->BString[x].Field=0;
 else this->BString[x].Field=1;
}
//---------------------------------
int BitString::FindStr(BitString x)
{
 unsigned long int y=x.SizeStr();
 for(unsigned long int i=0;i<=this->SizeStr();i++)
 {
  for(unsigned long int u=0;u<=y;u++)
  {
    if(this->BString[i+u].Field!=x.BString[u].Field)break;
    if(u==y)return (i+1);
  }
  
 } return 0;
}
//---------------------------------
void BitString::ReadStr(char*Path)
{
 this->ClearStr();
 unsigned char g=0;
 unsigned char h=1;

 Bit y;
 ifstream infile(Path,ios::in);
 while(infile.eof()==false)
 {
  infile>>g;
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g>>=1;
  }
 };
 
 infile.close();
}
//---------------------------------

//---------------------------------
void BitString::WriteStrRev(char *Path)
{
 unsigned char g=0;
 int f=0;
 ofstream files(Path,ios::out);
 for(unsigned long int count=0;count<=BString.size();count++)
 {
   if(f==8)
    {
     f=0;

     files<<g;
     g=0;
    }
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g=g+128;break;
              case 1:g=g+64; break;
              case 2:g=g+32; break;
              case 3:g=g+16; break;
              case 4:g=g+8;  break;
              case 5:g=g+4;  break;
              case 6:g=g+2;  break;
              case 7:g++;    break;
             }
    }


  f++;
 }
 files.close();
}


//-------------------------------
BitString::~BitString()
{
this->ClearStr();
}


//------------------------------
void BitString::Mod2(BitString x)
{
 unsigned long int y=0;
 if(this->SizeStr()>=x.SizeStr())y=x.SizeStr();
 if(this->SizeStr()<=x.SizeStr())y=this->SizeStr();
 do
 {
   this->BString.pop_back();
 }while(this->SizeStr()>y);
 for(unsigned long int i=0;i<=y;i++)
 {
  if(this->BString[i].Field==1&&x.BString[i].Field==1){this->BString[i].Field=0;continue;}
  if(this->BString[i].Field==0&&x.BString[i].Field==1){this->BString[i].Field=1;continue;}
  if(this->BString[i].Field==1&&x.BString[i].Field==0){this->BString[i].Field=1;continue;}
  if(this->BString[i].Field==0&&x.BString[i].Field==0){this->BString[i].Field=0;continue;}
 }

}

  //-----------------------------
int BitString::Count_0(void)
{
 int g=0;
 for(unsigned int count=0;count<=BString.size();count++)
 {
  if(BString[count].Field==0)g++;
 }
 return g;
}
//-----------------------------
int BitString::Count_1(void)
{
 int g=0;
 for(unsigned long int count=0;count<=BString.size();count++)
 {
  if(BString[count].Field==1)g++;
 }
 return g;
}
//-----------------------------
void BitString::SwapBit(unsigned long int x,unsigned long int y)
{
 p=BString.begin();
 Convert_Int_To_Bit(y-2);
 e=p;
 Convert_Int_To_Bit(x-2);
 iter_swap(p,e);
}
//-----------------------------
void BitString::EraseStr(unsigned long int x,unsigned long int y)
{
 p=BString.begin();
 Convert_Int_To_Bit(y);
 e=p;
 Convert_Int_To_Bit(x);
 BString.erase(p-1,e);
}
//-----------------------------
void BitString::EraseBit(unsigned long int index)
{
 p=BString.begin();
 Convert_Int_To_Bit(index);
 BString.erase(p-1);
}
//---------------- ------------


 
//------------------------------------
void BitString::WriteStr(char *Path)  
{
 unsigned char g=0;
 int f=0;
 ofstream files(Path,ios::out);
 for(unsigned long int count=0;count<=BString.size();count++)
 {
   if(f==8)
    {
     f=0;

     files<<g;
     g=0;
    }
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g++;    break;
              case 1:g=g+2;  break;
              case 2:g=g+4;  break;
              case 3:g=g+8;  break;
              case 4:g=g+16; break;
              case 5:g=g+32; break;
              case 6:g=g+64; break;
              case 7:g=g+128;break;
             }
    }


  f++;
 }
 files.close();
}
//------------------------------------
char* BitString::BitToChar(void)
{
 char *Ret;
 Ret=new char[this->BString.size()];
 for(unsigned long int count=0;count<=this->BString.size();count++)
 {
  if(this->BString[count].Field==1)Ret[count]='1';
  if(this->BString[count].Field==0)Ret[count]='0';
 }
 return Ret;
}

//------------------------------------
void BitString::StrToBit( char *s)
{
  BString.resize(0);
  for(unsigned long int count=0;count<=strlen(s)-1;count++)
  {
   assert(s[count]=='1'  || s[count]=='0');
   if(s[count]=='1')BString.push_back(bt1);
   if(s[count]=='0')BString.push_back(bt0);
  }
}
//------------------------------------


//------------------------------------
void BitString::JoinStr(BitString x)
{
 for(unsigned long i=0;i<=x.SizeStr();i++)
 {
   this->BString.push_back(x.BString[i]);
 }
}
//------------------------------------
void BitString::RightStr(int e)
{
 reverse(BString.begin(),BString.end());
 rotate(BString.begin(),BString.begin()+e,BString.end());
 reverse(BString.begin(),BString.end());
}
//------------------------------------
void BitString::LeftStr(int e)
{
 rotate(BString.begin(),BString.begin()+e,BString.end());
}

//------------------------------------
void BitString::ReverseStr()
{
  reverse(BString.begin(),BString.end());
}

//------------------------------------
void BitString::RandomStr(int index)
{
  int f;
  if(index<=5)f=index;
  else f=5;
  for(int i=1;i<=f;i++) random_shuffle(BString.begin(), BString.end());

}

//------------------------------------
void BitString::ReSizeStr(unsigned long int index,Bit Z)
{
 BString.resize(index,Z);
}
//------------------------------------

//------------------------------------
void BitString::PopBack()
{
 BString.pop_back();
}
//------------------------------------
void BitString::Convert_Int_To_Bit(unsigned long int index)
{
 this->p=BString.begin();
 for(unsigned long int count=0;count<=index;count++)
 {
   p++;
 }
}

//------------------------------------
void BitString::PuchBack(Bit Z)
{
 this->BString.push_back(Z);
}
//------------------------------------
unsigned long int BitString::MaxSize(void)
{
 return BString.max_size();
}
//------------------------------------
void BitString::InsertBit(unsigned long int index,unsigned long int Z,Bit h)   // ??????????????
{
  assert(h.Field==1 || h.Field==0);
  Convert_Int_To_Bit(index);
  BString.insert(p,Z,h);
}
//------------------------------------
void BitString::ClearStr(void)
{
 BString.clear();
}
//------------------------------------
unsigned long int BitString::SizeStr(void)
{
 return BString.size()-1;
 }
//------------------------------------
BitString::BitString()
{
   bt1.Field=1;
   bt0.Field=0;
   BString.push_back(bt0);
   BString.push_back(bt0);
   BString.push_back(bt0);
   p=BString.begin();
   e=BString.end();
}
//-----------------------------------
unsigned long int BitString::operator[](unsigned long int y)
{
 return BString[y].Field;
}
//------------------------------------
void BitString::operator=(BitString x)
{
 this->ClearStr();
 for(unsigned long int count=0;count<=x.SizeStr();count++)
 {
  if(x[count]==1) this->PuchBack(bt1);
  else this->PuchBack(bt0);
 }
}
//------------------------------------
main()
{
 unsigned int r;
BitString Str,rt;//  
Str.StrToBit("001101111111111111111000000000111100001011111111");
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;

cout<<"Write in file";cout<<endl;
Str.WriteStr("d:\\frt"); //
cout<<"Read from file";cout<<endl;
rt.ReadStr("d:\\frt");
for(unsigned int i=0;i<=rt.SizeStr();i++)cout<<rt[i];cout<<endl;
cout<<"Left<-";cout<<endl;cin>>r;
Str.LeftStr(r);
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;

cout<<"Right->";cin>>r; cout<<endl;
Str.RightStr(r);
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;
cout<<"Find string";
cout<<endl; rt.StrToBit("011110");
cout<<"Position "<< Str.FindStr(rt);
cout<<endl;
cout<<"Inver. bit";  cout<<endl;  cin>>r;
Str.InvBit(r);
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;
cin>>r;
cout<<"Inver.string";cout<<endl;
Str.InvStr();
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;

cin>>r;
BitString g;  g=Str;
cout<<"Sum mod(2) rt & Str";cout<<endl;
Str.Mod2(rt);
for(unsigned int i=0;i<=Str.SizeStr();i++)cout<<Str[i];cout<<endl;
cin>>r;
cout<<"Join string";
cout<<endl;
g.JoinStr(Str);
for(unsigned int i=0;i<=g.SizeStr();i++)cout<<g[i];cout<<endl;
cout<<"puch bits";cout<<endl;g.PuchBack(g.bt1);g.PuchBack(g.bt1);
for(unsigned int i=0;i<=g.SizeStr();i++)cout<<g[i];cout<<endl;
g.ConvertToRev(); cout<<"Convert bits in bayt" ;cout<<endl;
for(unsigned int i=0;i<=g.SizeStr();i++)cout<<g[i];cout<<endl;
cout<<"Erase bit"; cin>>r;
g.EraseBit(r);
for(unsigned int i=0;i<=g.SizeStr();i++)cout<<g[i];cout<<endl;
cout<<"Erase string"<<endl; cin>>r;
unsigned int y;
cin>>y;

g.EraseStr(r,y);
for(unsigned int i=0;i<=g.SizeStr();i++)cout<<g[i];cout<<endl;
cin>>r;
}




